﻿using UnityEngine;
using System.Collections;

public class BirdDiving : MonoBehaviour
{
	Vector2 startingPosition;
	Animator animator;

	void Start()
	{
		startingPosition = new Vector2 (transform.position.x, transform.position.y);
		transform.position += new Vector3 (0f, -5f, 0f);

		animator = GetComponent<Animator>();
	}

	void Update()
	{
		transform.position += new Vector3 (0f, 0.1f, 0f);

		float distance = Vector2.Distance(new Vector2(transform.position.x, transform.position.y), startingPosition);

		if (distance < 2f)
		{
			animator.SetTrigger("Elevate");

			GameObject[] humanoids = GameObject.FindGameObjectsWithTag("Humanoid");
			for (int i = 0; i < humanoids.Length; i++)
			{
				Vector2 humanPosition = new Vector2(humanoids[i].transform.position.x, humanoids[i].transform.position.y);
				if (Vector2.Distance (new Vector2(transform.position.x, transform.position.y), humanPosition) < 0.5f)
				{
					HumanoidController hc = GameObject.FindGameObjectWithTag("GameController").GetComponent<HumanoidController>();
					GameObject.Instantiate(hc.BloodTemplate, humanoids[i].transform.position, Quaternion.identity);

				    GameObject.Destroy(humanoids[i]);
				}
			}
		}
		else if (distance > 7f)
			GameObject.Destroy(gameObject);
	}
}