﻿using UnityEngine;
using System.Collections;

public class CameraMove : MonoBehaviour
{
	public float Speed = 2;
	Vector2 targetPos = Vector2.zero;
	Vector2 pos;
	public float speedReqToPlay = 1;

	void Start ()
	{
		targetPos = new Vector2 (transform.position.x, transform.position.y);
	}

	void Update ()
	{
		pos = new Vector2 (transform.position.x, transform.position.y);

		if (Vector2.Distance (targetPos, pos) > 3) 
		{
			float rotation = GameMath.RotationTo (pos, targetPos);
			rigidbody2D.AddForce(targetPos - pos);
		} 

		if (Vector2.Distance (targetPos, pos) > speedReqToPlay) 
		{
			if(!audio.isPlaying)
			{
				audio.Play();
			}
		}
		else if(audio.isPlaying)
		{
			audio.Stop();
		}
	}

	public void SetWaypoint (Vector2 targPos)
	{
		targetPos = targPos;
	}
}