﻿using UnityEngine;
using System.Collections;

public class CrashedPod : MonoBehaviour
{
	public GameObject Humanoid;
	public GameObject SpawnLocation;

	bool hasSpawnedHumanoids = false;
	bool isSpawning = false;
	int toSpawnLeft;

	float spawnTimer = 0f;
	float spawnTimerDelay = 300f;

	void Start()
	{
		transform.Rotate (new Vector3 (0f, 0f, Random.value * 360));
	}

	void Update()
	{
		if (isSpawning)
		{
			if (spawnTimer < spawnTimerDelay)
				spawnTimer += Time.deltaTime * 1000f;
			else
			{
				if (toSpawnLeft == 0)
				{
					isSpawning = false;
					return;
				}

				HumanoidController humanoidController = GameObject.FindGameObjectWithTag("GameController").GetComponent<HumanoidController>();
				Humanoid humanoid = humanoidController.SpawnRandomCivilianHumanoid(Vector3.zero);

				foreach (Transform spawnLocation in transform)
					humanoid.transform.position = spawnLocation.position;

				humanoid.MoveTowards(humanoidController.WaypointPosition);

				toSpawnLeft--;
				spawnTimer = 0f;
			}
		}
	}

	void OnTriggerEnter2D(Collider2D collider)
	{
		if (collider.gameObject.tag == "Humanoid")
		{
			if (!hasSpawnedHumanoids)
			{
				hasSpawnedHumanoids = true;
				isSpawning = true;
				toSpawnLeft = Random.Range(3, 7);
			}
		}
	}
}