﻿using UnityEngine;
using System.Collections;

public static class GameMath
{
	public static float RotationTo(Vector2 from, Vector2 to)
	{
		float xDist = to.x - from.x;
		float yDist = to.y - from.y;
		
		return Mathf.Atan2(yDist, xDist);
	}

	public static Vector2 RandomPointWithinCircle(float radius)
	{
		float u = Random.value + Random.value;
		float t = Random.value * Mathf.PI * 2f;
		float r = (u > 1) ? (u - 2) : u;
		
		return new Vector2(r * Mathf.Cos(t), r * Mathf.Sin(t)) * radius;
	}
}