﻿using UnityEngine;
using System.Collections;

public class Humanoid : MonoBehaviour
{
	public float MovementSpeed = 2;
	public Vector2 TargetPosition;
	public bool IsActive = true;

	bool isRoyal;
	SpriteRenderer spriteRenderer;

	void Start()
	{
		TargetPosition = new Vector2 (transform.position.x, transform.position.y);
	}

	void Awake()
	{
		spriteRenderer = GetComponent<SpriteRenderer>();
	}

	public void MoveTowards(Vector2 position)
	{
		TargetPosition = position;
	}

//	public bool GetIsRoyal()
//	{
//		return isRoyal;
//	}

	void Update()
	{
		if (!IsActive)
				return;

		Vector2 currentPosition = new Vector2 (transform.position.x, transform.position.y);
		float rotation = GameMath.RotationTo (currentPosition, TargetPosition);
		transform.eulerAngles = new Vector3(0f, 0f, (rotation * Mathf.Rad2Deg) + 90f);

		if (Vector2.Distance(currentPosition, TargetPosition) > 2f)
		{
			rigidbody2D.velocity = new Vector2 (Mathf.Cos (rotation), Mathf.Sin (rotation)) * MovementSpeed;

			if (Vector2.Distance (currentPosition, TargetPosition) < 2f)
			{
				TargetPosition = Vector2.zero;
				rigidbody2D.velocity = Vector2.zero;
				rigidbody2D.angularVelocity = 0f;
			}
		}
	}

	public bool GetIsRoyal(){
				return isRoyal;
    }


	public void SetData(Sprite sprite, bool isRoyal)
	{
		spriteRenderer.sprite = sprite;
		this.isRoyal = isRoyal;
	}
}