﻿using UnityEngine;
using System.Collections;

public class Wolf : GenericEnemy {

	RaycastHit hit;
	public Vector2 humanoidCoords;
	Vector2 aggroPos;
	public bool isAttacking;


	float chasingCounter = 0; //starts when eating, if bigger than the delay, set the wolf to be able to chase again
	public float chasingDelay = 10;
	bool canChase = true;

	float timeChasing = 0;
	public float timeBeforeGiveUp = 2;


public float attackingDelay = 3.5f;

	public override void Start () {
		humanoidCoords = Vector2.zero;
		base.Start ();
	}

	public override void Update () 
	{
		if (humanoidCoords != Vector2.zero && !isAttacking) 
		{ // chasing humanoid

			if(timeChasing < timeBeforeGiveUp)
			{
				timeChasing += Time.deltaTime;
			}
			else
			{
				rigidbody2D.velocity = Vector2.zero;

				humanoidCoords = Vector2.zero;

				isAttacking = false;
				chasingCounter = 0;
				canChase = false;
				timeChasing = 0;
			}

			Vector2 pos = new Vector2 (transform.position.x, transform.position.y);
			Vector2 dir = humanoidCoords - pos;
			dir.Normalize();
			rigidbody2D.velocity = dir * Speed;
			state = EnemyState.Attacking;
		} 
		else if (isAttacking) 
		{ // in the act of attacking humanoid
			humanoidCoords = Vector2.zero;
			rigidbody2D.velocity = Vector2.zero;
			isAttacking = false;
			chasingCounter = 0;
			canChase = false;
		} 
		else if (humanoidCoords == Vector2.zero && !isAttacking) 
		{//not chasing or attacking
			state = EnemyState.Idle;
			base.Update();
		}

		if (!canChase && chasingCounter < chasingDelay) 
		{
			//humanoidCoords = Vector2.zero;
			chasingCounter += Time.deltaTime;
			if(chasingCounter > chasingDelay)
			{
				canChase = true;
			}
		}
	
		float angle = Mathf.Atan2 (rigidbody2D.velocity.y, rigidbody2D.velocity.x) * Mathf.Rad2Deg + 90f;
		Quaternion ang = Quaternion.AngleAxis(angle, Vector3.forward);
		transform.rotation = Quaternion.RotateTowards(transform.rotation, ang, 125 * Time.deltaTime); 
	}

	public void SetHumanoidCoords(Vector2 coords)
	{
		humanoidCoords = coords;
	}

	public void SetIsAttacking(bool attacking)
	{
		isAttacking = attacking;
	}

	public bool GetIsAttacking()
	{
		return isAttacking;
	}

	public bool GetCanChase()
	{
		return canChase;
	}


}
