﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class WolfFollowHumanoid : MonoBehaviour {

	public Wolf wolf;
	public WolfSound wolfSound;
	public CrawlerSound crawlSound;
	
	List<Vector2> waypoints = new List<Vector2>();
	int currWP = 0;
	public bool ShouldLoopWaypoints = true;
	public bool ShouldWaypoints = false;


	// Use this for initialization
	void Start () {
	
		if(ShouldWaypoints)
		{
			waypoints.Add (new Vector2(transform.position.x, transform.position.y));
			
			foreach (Transform waypoint in transform)
			{
				if(waypoint.tag == "WayPoint")
				{
					waypoints.Add (new Vector2(waypoint.position.x, waypoint.position.y));
					Destroy (waypoint.gameObject);
				}
				
			}
		}

	
	}
	
	// Update is called once per frame
	void Update () {

		if(ShouldWaypoints)
		{

			Vector2 currPos = new Vector2 (transform.position.x, transform.position.y);
			if (Vector2.Distance (currPos, waypoints[currWP]) < 0.1f) 
			{
				if (currWP != 69) 
				{
					if (currWP < waypoints.Count-1) 
					{
						currWP++;
					} 
					else if (ShouldLoopWaypoints) 
					{
						currWP = 0;
					} else 
					{
						currWP = 69;
					}
				}
			}

			else if(currWP != 69)
			{
				float rotation = GameMath.RotationTo (currPos, waypoints [currWP]);
				
				rigidbody2D.velocity = new Vector2(Mathf.Cos (rotation), Mathf.Sin(rotation));
			}
		}
	
	}

	void OnTriggerStay2D(Collider2D other)
	{
		if (other.gameObject.tag == "Humanoid" && (wolf.GetCanChase() || wolf.type == EnemyType.BigEnem)) 
		{
			if(!audio.isPlaying)
			{
				if(wolf.type == EnemyType.Wolf)
					wolfSound.PlaySound();
				if(wolf.type == EnemyType.BigEnem)
					crawlSound.PlaySound();
			}
			Vector2 coords = new Vector2(other.gameObject.transform.position.x, other.gameObject.transform.position.y);
			wolf.SetHumanoidCoords(coords);
		}
	}
}